
const joiBrowser=require('joi-browser');

const has_=function(validationErrorType){
    let res;
    this.forEach(validationError=>{
        if(validationError.type===validationErrorType){
            res=validationError;
        }
    });        
    return res;
    }

function install (Vue, options) {
    let $joi=joiBrowser;
   if(options.extend) {            
       let extendType=Object.prototype.toString.call(options.extend);
       switch(extendType) {
           case  "[object Object]":
           $joi=$joi.extend(extendObject);  
           break;
           case  "[object Array]":
           options.extend.map((extendObject)=>{
               $joi=$joi.extend(extendObject);    
           });  
           break;             
           case "[object Function]":
           $joi=$joi.extend(options.extend);
           break;
       }                       
   }
   Vue.prototype.$joi=$joi;
   Vue.mixin({
       data() {
           return { joiValidationErrors:{} };
       },
       created() {
           this.doWatchForValidation();
       },
       methods:{
           doWatchForValidation(){
               let schema= this.joiValidationSchema();
               if(schema){
               schema._inner.children.forEach((schemaItem)=>{                                            
                  this.$watch(schemaItem.key, function(newValue, oldValue) {
                       let result=schemaItem.schema.validate(newValue);
                       if(result.error){                                
                           this.$set(this.joiValidationErrors,schemaItem.key, result.error.details);    
                           this.joiValidationErrors[schemaItem.key].has=has_;
                       }else{
                           delete this.joiValidationErrors[schemaItem.key];                                     
                       }
                   });
               });
           }
           },
           joiValidationSchema(validationTarget){                          
               const getSchemaKey=(schema, keyName)=>{
                   let foundedSchema;
                   schema._inner.children.forEach((schemaItem)=>{
                       if(schemaItem.key== keyName)
                       {
                           foundedSchema= schemaItem;
                       }
                   });
                   return foundedSchema;
               }                            
                   if(validationTarget!='' && typeof validationTarget=== "string") {
                     return getSchemaKey(this.joiValidationSchemaObject,validationTarget);
                   }else{
                    return this.joiValidationSchemaObject; 
                    }
            },
            getValidationValuesBaseOnSchema(){
               let schema= this.joiValidationSchema();
               let result={};
               if(schema){
               schema._inner.children.forEach((schemaItem)=>{                  
                   result[schemaItem.key]=this[schemaItem.key];
               });
               }
               return result;
            },
            joiValidate(){
                this.joiValidationErrors={};
                let validationValues=this.getValidationValuesBaseOnSchema();
                let validationResult=this.joiValidationSchemaObject.validate(validationValues, { abortEarly: false });
               if (validationResult.error){
                   validationResult.error.details.map(errorDetail=>{                                                                                             
                       if(!this.joiValidationErrors[errorDetail.path]){
                           this.$set(this.joiValidationErrors, errorDetail.path, [errorDetail]);     
                           this.joiValidationErrors[errorDetail.path].has=has_;                       
                       }
                   });
               }
               return validationResult;                     
            }
       }
 });
}    

module.exports={ 
    Joi: joiBrowser,
    install:install
  };
  
  
